/*
 * daytime.c
 */

__asm("	text\n	dc.b	'$Id: daytime.c,v 1.1 1998/10/14 19:12:20 sharl Exp $'\n	even\n");

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

char *__progname;

static void
usage()
{
	fprintf(stderr, "Usage: %s [-v] host\n", __progname);
	fprintf(stderr, "  -v: print version\n");
}

int
main(int argc, char *argv[])
{
	int sock;
	struct sockaddr_in saddr;
	struct hostent *shost;
	struct servent *serv, sserv;
	char *host, buf[256];
	char *p;
	int c;

	__progname = argv[0];
	while ((c = getopt(argc, argv, "v")) != EOF) {
		switch (c) {
			case 'v':
				fprintf(stderr, "%s " VERSION " (" PACKAGE ") (C)1998 Sharl <sharl@www.ufo.co.jp>\n", __progname);
				return EXIT_SUCCESS;
			default:
				usage();
				return EXIT_FAILURE;
		}
	}

	if (argc - 1 != optind){
		usage();
		return EXIT_FAILURE;
	}
	host = argv[optind];

	if ((serv = getservbyname("daytime", "tcp")) == NULL) {
		serv = &sserv;
		serv->s_port = 13;
	}
	memset(&saddr, 0, sizeof(saddr));
	if (isdigit(*host)) {
		saddr.sin_addr.s_addr = inet_addr(host);
		if ((shost = gethostbyaddr((char *)&saddr.sin_addr,
				sizeof(saddr.sin_addr), AF_INET)) == NULL) {
			fprintf(stderr, "gethostbyaddr() failed.\n");
			return EXIT_FAILURE;
		}
		host = shost->h_name;
	} else {
		shost = gethostbyname(host);
		if (shost) {
			memcpy(&saddr.sin_addr, shost->h_addr, shost->h_length);
		} else {
			fprintf(stderr, "%s: host name lookup failed.\n", host);
			return EXIT_FAILURE;
		}
	}

	saddr.sin_family = AF_INET;
	saddr.sin_port = htons(serv->s_port);

	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		fprintf(stderr, "can't create socket.\n");
		return 1;
	}
	if (connect(sock, (struct sockaddr *)&saddr, sizeof(struct sockaddr)) < 0) {
		fprintf(stderr, "%s: unable to connect: %s\n", host, strerror(errno));
		return EXIT_FAILURE;
	}
	read(sock, buf, sizeof(buf));
	for (p = buf; *p; p++) {
		if (*p == '\n') {
			*p = '\0';
			break;
		}
	}
	puts(buf);
	close(sock);
	return EXIT_SUCCESS;
}
